/*
 * PWM-Funktionen fr ATMega8 und kompatible
 * fr Controller-Board turi
 *
 * vielen Dank an conker fr die Init-Funktion
 *
 */


//LEDs festlegen auf Hardware-PWM-Ausgnge
#define LEDr OCR1B
#define LEDg OCR1A
#define LEDb OCR2B
#define LEDw OCR2A




void initPWM (void)
{

	// OC1A=PB1, OC1B=PB2, OC2A=PB3, OC2B=PD3
   	DDRB  |= ( 1 << DDB1 | 1<<DDB2 | 1<<DDB3 );		//0b00001110;             
   	PORTB |= ( 1 << PB1 | 1<<PB2 | 1<<PB3 );		//0b00001110;            
   	DDRD  |= ( 1 << DDD3 );							//0b00001000;             
   	PORTD |= ( 1 << PD3 );							//0b00001000;            



  //DDRB |= (1 << PB3);
  //DDRD |= (1 << PD3) | (1 << PD5) | (1 << PD6);
  ////////////////////////////////////////////////////////////////////////////
#if defined (__AVR_ATmega8__) || defined (__AVR_AT90S2313__) \
		|| defined (__AVR_ATmega32__) || defined (__AVR_ATmega16__)
  ////////////////////////////////////////////////////////////////////////////

  //8-Bit-PWM initialisieren - Timer 1
  TCCR1A = 0xA1;		//  8 Bit Phase correct PWM 
  TCCR1B |= (0 << CS12) | (1 << CS11) | (1 << CS10);			// Prescale 64 

  // Timer 2
  TCCR2 =
    (1 << COM21) | (0 << COM20) | (0 << WGM21) | (1 << WGM20) | (1 << CS22) |
    (0 << CS21) | (0 << CS20); // Prescale 64

  ////////////////////////////////////////////////////////////////////////////
#elif defined (__AVR_ATmega48__) || defined (__AVR_ATmega88__) \
		|| defined (__AVR_ATmega168__)
  ////////////////////////////////////////////////////////////////////////////

  //8-Bit-PWM initialisieren - Timer 1
  TCCR1A = 0xA1;		//  8 Bit Phase correct PWM 
  TCCR1B |= (0 << CS12) | (1 << CS11) | (1 << CS10);			// Prescale 64 

  // Timer 2
  TCCR2A =
    (1 << COM2A1) | (0 << COM2A0) | (1 << COM2B1) | (0 << COM2B0) 
    | (1 <<  WGM20);
  TCCR2B =  (1 << CS22) | (0 << CS21) | (0 << CS20);			// Prescale 64

  ////////////////////////////////////////////////////////////////////////////
#else
#   error This AVR derivative is (not yet) supported.
#   error Feel free to add the required code.
#endif // AVR derivatives
  ////////////////////////////////////////////////////////////////////////////
}

