#include <avr/io.h>
#include <stdint.h>
#include <avr/interrupt.h>

//falls DIP-Schalter vorhanden
//#define  USE_DIP
//#define  F_OSC			(8000)		  		//oscillator freq. in kHz (typical 8MHz or 16MHz)
#ifndef F_CPU
  #define F_CPU     	8000000L       	// system clock in Hz
#endif
#define dmx_size 20						 // number of used DMX channels
#define BAUD 250000L					 // DMX512      	

#define UBRR_VAL  ((F_CPU+BAUD*8)/(BAUD*16)-1)  
#define BAUD_REAL (F_CPU/(16*(UBRR_VAL+1))) 	
#define BAUD_ERROR ((BAUD_REAL*1000)/BAUD-1000) 


 
#if ((BAUD_ERROR>10) || (BAUD_ERROR<-10))
  #error Systematic baud error above 1% which is too high! 
#endif
 

volatile uint8_t	 DmxRxField[dmx_size]; 		//array of DMX vals (raw)
volatile uint16_t 	 DMXStartAddress=1;	//DMX-Startadresse


extern void    init_DMX_RX(void);
extern void    get_dips(void);
